unit Unit1;

{$mode objfpc}{$H+}


interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,

  fpHttpClient, fpOpenSSL, OpenSSL, DOM, XMLWrite;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  http: TFPHTTPClient;
  Request, Response: TStream;
  XMLDoc: TXMLDocument;
  aRoot, aMethodName, aMethodValue: TDOMNode;
begin
  // XML Dokument erzeugen
  XMLDoc := TXMLDocument.Create;

  // Wurzelknoten erzeugen
  aRoot := XMLDoc.CreateElement('methodCall');
  XMLDoc.AppendChild(aRoot);

  // Kind Element erzeugen
  aRoot := XMLDoc.DocumentElement;
  aMethodName := XMLDoc.CreateElement('methodName');

  // Wert für Kind Element
  aMethodValue := XMLDoc.CreateTextNode('fldigi.version');
  aMethodName.AppendChild(aMethodValue);

  // Elemente sichern
  aRoot.AppendChild(aMethodName);

  // Daten holen
  InitSSLInterface;
  http := TFPHTTPClient.Create(nil);
  Response := TMemoryStream.Create;
  Request := TMemoryStream.Create;
  try
    WriteXML(XMLDoc, Request);
    Request.Seek(0, soFromBeginning);             // <-- Warum ???
    http.RequestBody := Request;
    try
      http.Post('http://127.0.0.1:7362', Response);
      Response.Seek(0, soFromBeginning);            // <-- Warum ???
      if http.ResponseStatusCode = 200 then
        Memo1.Lines.LoadFromStream(Response);
    except
      Memo1.Clear;
      Memo1.Lines.Add('unbekannter Fehler.')
    end;
  finally
    http.Free;
    Response.Free;
    Request.Free;
    XMLDoc.Free;
  end;
end;

end.

